/* 
    Copyright (C) 2004  Mika Raento - Renaud Petit

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    email: mraento@cs.helsinki.fi - petit@cs.helsinki.fi 
*/


#ifndef CL_SETTINGS_H_INCLUDED
#define CL_SETTINGS_H_INCLUDED 1

// don't use 'IAP', since there is
// a macro with that name in cdbcols.h

#define SETTING_WAP_AP	1
#define SETTING_PHONENO 2
#define SETTING_IP_AP   3
#define SETTING_LAST_COMMLOG_UPLOAD 4
#define SETTING_CELLMAP_CLOSED 5
#define SETTING_BASEDB_VERSION 6
#define SETTING_JABBER_NICK 7
#define SETTING_JABBER_PASS 8
#define SETTING_PRESENCE_ENABLE 9
#define SETTING_LAST_BASE_STAMP 10
#define SETTING_PICTURE_ENABLE 11
#define SETTING_UPLOAD_URLBASE 12
#define SETTING_PREV_BASE 13
#define SETTING_PREV_BASE_STAMP 14
#define SETTING_UPLOAD_TAG 15
#define SETTING_OPTIONS_ENABLE 16
#define SETTING_DELETE_UPLOADED	17
#define SETTING_LOGGING_ENABLE	18
#define SETTING_LOCATIONSERVICE_ENABLE 19
#define SETTING_BT_SCAN_INTERVAL 20
#define SETTING_RECORD_ALL 21
#define SETTING_LOG_UPLOAD_ENABLE 22
#define SETTING_TAG_ONLY 23
#define SETTING_PROMPT_FOR_NAMES 24
#define SETTING_UPLOAD_PROMPT_TYPE 25
#define SETTING_PUBLISH_URLBASE 26
#define SETTING_VIBRATE_ONLY 27
#define SETTING_GPS_BT_ADDR 28
#define SETTING_GPS_LOG_TIME 29
#define SETTING_GPS_BT_PORT 30
#define SETTING_PUBLISH_AUTHOR 31

#define SETTINGS_COUNT 32 // real count +1 for array bounds

#define MAX_ADDRESS_LEN 30
#define MAX_URL_LEN	100

#ifndef SETTING_DEFINES_ONLY

#include <settings.h>

class TClSettings : public MDefaultSettings {
public:
	static const TSettingItem KClSettings[];
private:
	virtual bool GetDefaultL(TInt Setting, TDes& Value) const;
	virtual bool GetDefaultL(TInt Setting, TDes8& Value) const;
	virtual bool GetDefaultL(TInt Setting, TInt& Value) const;
	virtual bool GetDefaultL(TInt Setting, TTime& Value) const;
};

#endif

#endif
